﻿Imports FarPoint.Win.Spread
Imports System.Reflection

Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        FpSpread1.Sheets.Count = 2
        FpSpread1.Sheets(0).RowCount = 10
        FpSpread1.Sheets(0).ColumnCount = 5
        FpSpread1.Sheets(0).Cells(0, 0, FpSpread1.Sheets(0).RowCount - 1, FpSpread1.Sheets(0).ColumnCount - 1).Text = "Test 1"
        FpSpread1.Sheets(0).Columns(0).BackColor = Color.Aqua
        FpSpread1.Sheets(0).Columns(2).BackColor = Color.AliceBlue
        FpSpread1.Sheets(0).Columns(4).BackColor = Color.Cyan
        FpSpread1.Sheets(1).RowCount = 10
        FpSpread1.Sheets(1).ColumnCount = 5
        FpSpread1.Sheets(1).Cells(0, 0, FpSpread1.Sheets(0).RowCount - 1, FpSpread1.Sheets(0).ColumnCount - 1).Text = "Test 2"
        FpSpread1.Sheets(1).Columns(1).BackColor = Color.Aqua
        FpSpread1.Sheets(1).Columns(3).BackColor = Color.AliceBlue
    End Sub

    Private Sub btnCloneSpread_Click(sender As System.Object, e As System.EventArgs) Handles btnCloneSpread.Click
        Dim clonedSpread As FpSpread = fpSpreadClone(FpSpread1)
        Controls.Add(clonedSpread)
        clonedSpread.Left = FpSpread1.Right
        clonedSpread.Top = FpSpread1.Top
        clonedSpread.Width = FpSpread1.Width
        clonedSpread.Height = FpSpread1.Height

    End Sub
    Private Function fpSpreadClone(baseObject As FpSpread) As FpSpread
        'Copying to a memory stream
        Dim ms As New System.IO.MemoryStream()
        FarPoint.Win.Spread.Model.SpreadSerializer.SaveXml(FpSpread1, ms, False)
        ms = New System.IO.MemoryStream(ms.ToArray())

        'Copying from memory stream to clone spread object
        Dim newSpread As New FarPoint.Win.Spread.FpSpread()
        FarPoint.Win.Spread.Model.SpreadSerializer.OpenXml(newSpread, ms)


        Dim fInfo As FieldInfo() = GetType(FarPoint.Win.Spread.FpSpread).GetFields(BindingFlags.Instance Or BindingFlags.[Public] Or BindingFlags.NonPublic Or BindingFlags.[Static])
        For Each field As FieldInfo In fInfo
            If field IsNot Nothing Then
                Dim del As [Delegate] = Nothing
                If field.FieldType.Name.Contains("EventHandler") Then
                    del = DirectCast(field.GetValue(baseObject), [Delegate])
                End If

                If del IsNot Nothing Then
                    Dim eInfo As EventInfo = GetType(FarPoint.Win.Spread.FpSpread).GetEvent(del.Method.Name.Substring(del.Method.Name.IndexOf("_"c) + 1))
                    If eInfo IsNot Nothing Then
                        eInfo.AddEventHandler(newSpread, del)
                    End If
                End If
            End If
        Next

        Return newSpread
    End Function

    Private Sub FpSpread1_CellClick(sender As Object, e As FarPoint.Win.Spread.CellClickEventArgs) Handles FpSpread1.CellClick
        MessageBox.Show("You clicked cell " & e.Row & " , " & e.Column)
    End Sub
End Class
